#Name: New UI - Single Extruder
#Info: Bigger UI with more buttons for a single extruder!
#Depend: printwindow
#Type: printwindow

# Printer UI based on the Printrun interface by Kliment plus fan.
# Increased windiw size and added more buttons for manual use
# Printrun is GPLv3, so this file, and the used images are GPLv3

setImage('image.png', 'map.png')

# X-axis

addColorCommand(0, 0, 255, sendGCode, "G91; G1 X100 F2000; G90")
addColorCommand(0, 0, 240, sendGCode, "G91; G1 X10 F2000; G90")
addColorCommand(0, 0, 220, sendGCode, "G91; G1 X1 F2000; G90")
addColorCommand(0, 0, 200, sendGCode, "G91; G1 X0.1 F2000; G90")
addColorCommand(0, 0, 180, sendGCode, "G91; G1 X-0.1 F2000; G90")
addColorCommand(0, 0, 160, sendGCode, "G91; G1 X-1 F2000; G90")
addColorCommand(0, 0, 140, sendGCode, "G91; G1 X-10 F2000; G90")
addColorCommand(0, 0, 120, sendGCode, "G91; G1 X-100 F2000; G90")

# Y-Axis

addColorCommand(0, 255, 0, sendGCode, "G91; G1 Y100 F2000; G90")
addColorCommand(0, 240, 0, sendGCode, "G91; G1 Y10 F2000; G90")
addColorCommand(0, 220, 0, sendGCode, "G91; G1 Y1 F2000; G90")
addColorCommand(0, 200, 0, sendGCode, "G91; G1 Y0.1 F2000; G90")
addColorCommand(0, 180, 0, sendGCode, "G91; G1 Y-0.1 F2000; G90")
addColorCommand(0, 160, 0, sendGCode, "G91; G1 Y-1 F2000; G90")
addColorCommand(0, 140, 0, sendGCode, "G91; G1 Y-10 F2000; G90")
addColorCommand(0, 120, 0, sendGCode, "G91; G1 Y-100 F2000; G90")

# Z-Axis

addColorCommand(255, 0, 0, sendGCode, "G91; G1 Z10 F200; G90")
addColorCommand(220, 0, 0, sendGCode, "G91; G1 Z1 F200; G90")
addColorCommand(200, 0, 0, sendGCode, "G91; G1 Z0.1 F200; G90")
addColorCommand(180, 0, 0, sendGCode, "G91; G1 Z-0.1 F200; G90")
addColorCommand(160, 0, 0, sendGCode, "G91; G1 Z-1 F200; G90")
addColorCommand(140, 0, 0, sendGCode, "G91; G1 Z-10 F200; G90")

# Home, X-,Y-,Z-Axis

addColorCommand(255, 255, 0, sendGCode, "G28")
addColorCommand(240, 255, 0, sendGCode, "G28 X0")
addColorCommand(220, 255, 0, sendGCode, "G28 Y0")
addColorCommand(200, 255, 0, sendGCode, "G28 Z0")

# Extrude/Retract
addColorCommand(245, 0, 0, sendGCode, "G92 E0; G1 F200 E10; G92 E0")
addColorCommand(230, 0, 0, sendGCode, "G92 E0; G1 F200 E1; G92 E0")
addColorCommand(210, 0, 0, sendGCode, "G92 E0; G1 F200 E0.1; G92 E0")
addColorCommand(190, 0, 0, sendGCode, "G92 E0; G1 F200 E-0.1; G92 E0")
addColorCommand(170, 0, 0, sendGCode, "G92 E0; G1 F200 E-1; G92 E0")
addColorCommand(150, 0, 0, sendGCode, "G92 E0; G1 F200 E-10; G92 E0")

# Fan

addColorCommand(0, 1, 0, sendGCode, "M107")
addColorCommand(0, 1, 5, sendGCode, "M106 S13")
addColorCommand(0, 1, 10, sendGCode, "M106 S26")
addColorCommand(0, 1, 15, sendGCode, "M106 S38")
addColorCommand(0, 1, 20, sendGCode, "M106 S51")
addColorCommand(0, 1, 25, sendGCode, "M106 S64")
addColorCommand(0, 1, 30, sendGCode, "M106 S77")
addColorCommand(0, 1, 35, sendGCode, "M106 S89")
addColorCommand(0, 1, 40, sendGCode, "M106 S102")
addColorCommand(0, 1, 45, sendGCode, "M106 S115")
addColorCommand(0, 1, 50, sendGCode, "M106 S128")
addColorCommand(0, 1, 55, sendGCode, "M106 S140")
addColorCommand(0, 1, 60, sendGCode, "M106 S153")
addColorCommand(0, 1, 65, sendGCode, "M106 S166")
addColorCommand(0, 1, 70, sendGCode, "M106 S179")
addColorCommand(0, 1, 75, sendGCode, "M106 S191")
addColorCommand(0, 1, 80, sendGCode, "M106 S204")
addColorCommand(0, 1, 85, sendGCode, "M106 S217")
addColorCommand(0, 1, 90, sendGCode, "M106 S230")
addColorCommand(0, 1, 95, sendGCode, "M106 S242")
addColorCommand(0, 1, 100, sendGCode, "M106 S255")

# Terminal,Temp,Progress

addTerminal(255, 0, 255)
addTemperatureGraph(180, 0, 255)
addProgressbar(255, 200, 200)

# Buttons

addButton(0, 255, 255, 'Connect', connect)
addButton(0, 240, 255, 'Print', startPrint)
addButton(0, 220, 255, 'Pause', pausePrint)
addButton(0, 200, 255, 'Cancel', cancelPrint)
addButton(0, 180, 255, 'Error log', showErrorLog)

#Print stuff to terminal buttons
#current position
addColorCommand(74, 50, 152, sendGCode, "M114")
#endstops
addColorCommand(74, 80, 152, sendGCode, "M119")
#current settings
addColorCommand(74, 95, 152, sendGCode, "M503")
#Stop Steppers
addColorCommand(74, 35, 152, sendGCode, "M84")

    ######
    # these are common and could/should migrate to Cura.gui.printWindow/printWindowPlugin
    # they will need to be added to the 'variables' passed to the 'execfile' in __init__
     
def parentFrame():
	return setImage.im_self # this magic is only needed in this plugin, it's the 'self' of printWindowPlugin
     
def addPanel(r,g,b):
	printWindowPlugin = parentFrame()	# magic :)
	x, y, w, h = printWindowPlugin._getColoredRect(r,g,b)
	panel= wx.Panel(printWindowPlugin)
	panel.SetPosition((x, y))
	panel.SetSize((w, h))
	return panel
     
def createButton(parent, text, command, data = None):
	button = wx.Button(parent, -1, _(text))
	button.command = command
	button.data = data
	printWindowPlugin = parentFrame()	
	printWindowPlugin.Bind(wx.EVT_BUTTON, lambda e: command(data), button)
	return button


    ### Below is the custom GUI Panel to control 2 extruders
import wx
     
    # this could live in its own module and would make assembly of different GUI plugins in a single printer GUI window easier to manage
class ExtruderTemperaturePluginPanel(): 
	def __init__(self, r,g,b):

######################################################
##		Change these values for button temperatures ##
		defaultTemp = "185"
		defaultBedTemp = "57"
##                                                  ##
######################################################

		panel = addPanel(r,g,b)
		self.tool0_temp = wx.TextCtrl(panel, -1, value="0")
		self.tool0_zero = createButton(panel, "Set 0", sendGCode, "M104 S0")
		self.tool0_default = createButton(panel, "Set " + defaultTemp, sendGCode, "M104 S" + defaultTemp)
		self.tool0_setTemp = createButton(panel, "Set:", lambda s: sendGCode("M104 S" + s.GetValue()), self.tool0_temp)
		
		self.heatbed_temp = wx.TextCtrl(panel, -1, value="0")
		self.heatbed_zero = createButton(panel, "Set 0", sendGCode, "M140 S0")
		self.heatbed_default = createButton(panel, "Set " + defaultBedTemp, sendGCode, "M140 S" + defaultBedTemp)
		self.heatbed_setTemp = createButton(panel, "Set:", lambda s: sendGCode("M140 S" + s.GetValue()), self.heatbed_temp)		
		 
		sizer = wx.GridSizer(rows=10, cols=5, hgap=10, vgap=10)
		sizer.Add(wx.StaticText(panel, -1, label="Extruder"), 0, wx.TOP|wx.BOTTOM|wx.LEFT|wx.ALIGN_CENTER, 10)
		sizer.Add(self.tool0_zero, 0, wx.TOP|wx.BOTTOM, 10)
		sizer.Add(self.tool0_default, 0, wx.TOP|wx.BOTTOM, 10)
		sizer.Add(self.tool0_setTemp, 0, wx.TOP|wx.BOTTOM, 10)
		sizer.Add(self.tool0_temp, 0, wx.TOP|wx.BOTTOM, 10)
		sizer.Add(wx.StaticText(panel, -1, label = "Heat Bed"), 0, wx.TOP|wx.BOTTOM|wx.LEFT|wx.ALIGN_CENTER, 10)
		sizer.Add(self.heatbed_zero, 0, wx.TOP|wx.BOTTOM, 10)
		sizer.Add(self.heatbed_default, 0, wx.TOP|wx.BOTTOM, 10)
		sizer.Add(self.heatbed_setTemp, 0, wx.TOP|wx.BOTTOM, 10)
		sizer.Add(self.heatbed_temp, 0, wx.TOP|wx.BOTTOM, 10)

		panel.SetSizer(sizer)
		panel.Layout()

ExtruderTemperaturePluginPanel(255, 123, 255)
